﻿local oldCombineAddCutterArea = Combine.addCutterArea;
Combine.addCutterArea = function(self, cutter, area, realArea, inputFruitType, fruitType)

	--DURAL 20131017 - apply the correct computing of yield for "non mr" combines too.
	--if not self.isRealistic then
	--	return oldCombineAddCutterArea(self, cutter, area, realArea, inputFruitType, fruitType);
	--end;


      if area > 0 and (self.lastCuttersFruitType == FruitUtil.FRUITTYPE_UNKNOWN or self.lastCuttersArea == 0 or self.lastCuttersFruitType == fruitType) then
          self.lastCuttersArea = self.lastCuttersArea + area;
          self.lastCuttersFruitType = fruitType;
          self.lastCuttersInputFruitType = inputFruitType;
          self.lastCuttersAreaTime = self.time;
          local outputFruitType = fruitType;
          if self.convertedFruits[fruitType] ~= nil then
              outputFruitType = self.convertedFruits[fruitType];
          end;
          local fruitDesc = FruitUtil.fruitIndexToDesc[outputFruitType];
          self.chopperActivated = not fruitDesc.hasWindrow;
  
          if self.chopperActivated then
              if self.chopperEnableTime == nil then
                  self.chopperEnableTime = self.time + self.chopperToggleTime;
              end
              self.chopperDisableTime = nil;
          else
              self.strawAreaToDrop = self.strawAreaToDrop + realArea;
              if self.strawEnableTime == nil then
                  self.strawEnableTime = self.time + self.strawToggleTime;
              end
              self.strawDisableTime = nil;
          end
  
          -- 8000/1200 = 6.66 liter/meter
          -- 8000/1200 / 6 = 1.111 liter/m^2
          -- 8000/1200 / 6 / 2^2 = 0.277777 liter / density pixel (density is 4096^2, on a area of 2048m^2
          local pixelToSqm = g_currentMission:getFruitPixelsToSqm(); -- 4096px are mapped to 2048m
          local literPerSqm = 1;
		  
--*********************************   DURAL  ******************************************************************************
--** output fruit yield do not depend on input fruit type yield !!! 
--** ex : corn yield is "only" 11T/ha whereas grass yield will be 30T/ha... but corn chaff is 50T/ha whereas grass chaff is 30T/ha and drygrass chaff is only 6T/ha
--** => its best to create one fruittype for each output fruit (example : grass's chaff is different from corn's chaff)
                           --literPerSqm = literPerSqm * FruitUtil.fruitIndexToDesc[outputFruitType].literPerSqm;
		  
			local compoundFruitName = FruitUtil.fruitIndexToDesc[inputFruitType].name;
			local isCompound = false;
			if (fruitType ~= inputFruitType and fruitType ~= FruitUtil.FRUITTYPE_UNKNOWN) then
				compoundFruitName = compoundFruitName .. "_" .. FruitUtil.fruitIndexToDesc[fruitType].name;
				isCompound = true;
			end;
			if (outputFruitType ~= fruitType and outputFruitType ~= FruitUtil.FRUITTYPE_UNKNOWN) then
				compoundFruitName = compoundFruitName .. "_" .. FruitUtil.fruitIndexToDesc[outputFruitType].name;
				isCompound = true;
			end;
			
			literPerSqm = FruitUtil.fruitIndexToDesc[fruitType].literPerSqm;
			if isCompound then
				local found, compoundLiterPerSqm = RealisticUtils.getOutputCompoundFruitLiterPerSqmV2(compoundFruitName);
				if found then
					literPerSqm = compoundLiterPerSqm;
				end;
			end;
		  
--*********************************  END DURAL   **************************************************************************	

          local sqm = area*pixelToSqm;
		  
		  --print(self.time .. " - Combine.addCutterArea - literPerSqm="..tostring(literPerSqm).." - liter per Ha="..tostring(literPerSqm*10000) .. " - sqm="..tostring(sqm) .. " - area="..tostring(area).." - realArea="..tostring(realArea));
  
          local deltaFillLevel = sqm*literPerSqm*self.threshingScale;
  
          local newFillLevel = self.grainTankFillLevel+deltaFillLevel;
          self:setGrainTankFillLevel(newFillLevel, outputFruitType);
      end;
  end
  
  
  
  
  
  
local oldCombineDraw = Combine.draw;
Combine.draw = function(self)

	if not self.isRealistic then
		return oldCombineDraw(self);
	end;


	if self.isClient then
		local percent = 0;
		if self.grainTankCapacity > 0 then
			percent = self.grainTankFillLevel/self.grainTankCapacity*100;
			if self.currentPipeState == 2 and not self.pipeIsUnloading and self.grainTankFillLevel > 0 then
				g_currentMission:addExtraPrintText(g_i18n:getText("Move_the_pipe_over_a_trailer"));
			elseif self.grainTankFillLevel == self.grainTankCapacity then
				g_currentMission:addExtraPrintText(g_i18n:getText("Dump_corn_to_continue_threshing"));
			end;
		end;
		if self.isThreshing then
			g_currentMission:addHelpButtonText(g_i18n:getText("Turn_off_combine"), InputBinding.ACTIVATE_THRESHING);
		else
			if self:getIsStartThreshingAllowed() then
				g_currentMission:addHelpButtonText(g_i18n:getText("Turn_on_combine"), InputBinding.ACTIVATE_THRESHING);
			end
		end
		if self.numPipeStates == 2 then
			if self.targetPipeState == 2 then
				if self:getIsPipeStateChangeAllowed(1) then
					g_currentMission:addHelpButtonText(g_i18n:getText("Pipe_in"), InputBinding.EMPTY_GRAIN);
				end
			else
				if self:getIsPipeStateChangeAllowed(2) and (percent > 0 or self.grainTankCapacity <= 0) then
					g_currentMission:addHelpButtonText(g_i18n:getText("Dump_corn"), InputBinding.EMPTY_GRAIN);
				end
			end
		end;
  
		if self.currentGrainTankFruitType ~= FruitUtil.FRUITTYPE_UNKNOWN then
			g_currentMission:setFruitOverlayFruitType(self.currentGrainTankFruitType);
		elseif self.lastValidGrainTankFruitType ~= FruitUtil.FRUITTYPE_UNKNOWN and self.lastCuttersAreaTime + 250 > self.time then
			g_currentMission:setFruitOverlayFruitType(self.lastValidGrainTankFruitType);
		end;

--*********************************   DURAL  ******************************************************************************
-- not useful anymore. see RealisticCombine:realGetIsWorkingTooFast		
		--[[
          local printSpeedLevelWarning = false;
          local speedLevelStr;
  --        local speedLevelKeyStr;
          local speedLevel = 10;
          for cutter, _ in pairs(self.attachedCutters) do
              if math.abs(cutter.speedViolationTimer - cutter.speedViolationMaxTime) > 2 then
                  printSpeedLevelWarning = true;
                  if Cutter.getUseLowSpeedLimit(cutter) then
                      if speedLevel > 1 then
                          speedLevel = 1;
                          speedLevelStr = "1";
  --                        speedLevelKeyStr = InputBinding.getKeyNamesOfDigitalAction(InputBinding.SPEED_LEVEL1)
                      end;
                  else
                      if speedLevel > 2 then
                          speedLevel = 2;
                          speedLevelStr = "2";
  --                        speedLevelKeyStr = InputBinding.getKeyNamesOfDigitalAction(InputBinding.SPEED_LEVEL2)
                      end;
                  end;
              end;
          end;]]
  
          if self.isThreshing and not self:getIsThreshingAllowed(false) then
              g_currentMission:addWarning(g_i18n:getText("Dont_do_threshing_during_rain_or_hail"), 0.018, 0.033);
--*********************************   DURAL  ******************************************************************************
-- not useful anymore. see RealisticCombine:realGetIsWorkingTooFast
          --[[elseif printSpeedLevelWarning then
              g_currentMission:addWarning(g_i18n:getText("Dont_drive_to_fast") .. "\n" .. string.format(g_i18n:getText("Cruise_control_levelN"), speedLevelStr), 0.07+0.022, 0.019+0.029);]]
          end;
      end;
  
  end;
  
  
  
  --******************************************* DURAL ***********************************************************************************
  --light on the beacon light when the fill level reach the warning fill level
 local oldCombineSetGrainTankFillLevel =   Combine.setGrainTankFillLevel;
 Combine.setGrainTankFillLevel = function (self, fillLevel, fruitType)
 
	local previousFillLevel = self.grainTankFillLevel;
	
	oldCombineSetGrainTankFillLevel(self, fillLevel, fruitType);	
 
	if self.isClient and self.isRealistic and self.realInitialized and self.grainTankCapacity>0 then -- realInitialized because "setGrainTankFillLevel" is called during "combine.load" and so, realCombineGrainTankLevelPercentForBeaconLight is not set yet at this time
		local warningFillLevel = self.realCombineGrainTankLevelPercentForBeaconLight*self.grainTankCapacity;
		if self.grainTankFillLevel>=warningFillLevel then
			if previousFillLevel<warningFillLevel then
				--toggle on the beaconlight
				self:setBeaconLightsVisibility(true);
			end;
		else
			--desactivate the beacon
			if previousFillLevel>=warningFillLevel then
				--toggle off the beaconlight
				self:setBeaconLightsVisibility(false);
			end;
		end;
	end;
 
 end;
  
  
  
  
  --[[
 Cutter.onStopReel = function(self)
 
	print(self.time .. " Cutter:onStopReel");
       self.reelStarted = false;
       Utils.setEmittingState(self.threshingParticleSystems, false);
       self.speedViolationTimer = self.speedViolationMaxTime;
   
       for _, part in pairs(self.cutterThreshingUVScrollParts) do
           setShaderParameter(part.node, "uvScrollSpeed", 0, 0, 0, 0, false);
       end;
   
       if self.cutterStartAnimation ~= nil and self.playAnimation ~= nil then
           self:playAnimation(self.cutterStartAnimation, -self.cutterStartAnimationSpeedScale, nil, true);
       end
   end;
 
  Cutter.onDeactivate = function(self)
	print(self.time .. " Cutter:onDeactivate - " .. tostring(self.realVehicleName) .. " - self.onDeactivate=".. tostring(self.deactivateOnLeave ));
       self:onStopReel();
       Utils.setEmittingState(self.threshingParticleSystems, false);
       self.speedViolationTimer = self.speedViolationMaxTime;
   end;
   
   Cutter.onLeave = function(self)
		print(self.time .. " Cutter:onLeave - " .. tostring(self.realVehicleName) .. " - self.deactivateOnLeave=".. tostring(self.deactivateOnLeave ));
       if self.deactivateOnLeave then
           Cutter.onDeactivate(self);
       end;
   end;
   
   
   function Vehicle:onDeactivateAttachments()
   
	print(self.time .. " Vehicle:onDeactivateAttachments - " .. tostring(self.realVehicleName) .. " - self.deactivateOnLeave=".. tostring(self.deactivateOnLeave ));
   
      for _,v in pairs(self.attachedImplements) do
          if v.object ~= nil then
              v.object:onDeactivate();
          end
      end;
  end;
  
  
  function Vehicle:onDeactivate()
	print(self.time .. " Vehicle:onDeactivate - " .. tostring(self.realVehicleName) .. " - self.deactivateOnLeave=".. tostring(self.deactivateOnLeave ));
  
      self:onDeactivateAttachments();
      for k,v in pairs(self.specializations) do
          if v.onDeactivate ~= nil then
              v.onDeactivate(self);
          end;
      end;
  end;

--]]


  
  
  
  
  
  
  