Windrower.additionnalLoad1 = function(self, xmlFile)

	self.speedRotatingParts = {};
	local i=0;
	while true do
		local baseName = string.format("vehicle.speedRotatingParts.speedRotatingPart(%d)", i);
		local index = getXMLString(xmlFile, baseName.. "#index");
		if index == nil then
			break;
		end;
		local node = Utils.indexToObject(self.components, index);
		if node ~= nil then
			local entry = {};
			entry.node = node;
			entry.rotationSpeedScale = getXMLFloat(xmlFile, baseName.."#rotationSpeedScale");
			if entry.rotationSpeedScale == nil then
				entry.rotationSpeedScale = 1.0/Utils.getNoNil(getXMLFloat(xmlFile, baseName.."#radius"), 1);
			end;

			entry.foldMinLimit = Utils.getNoNil(getXMLFloat(xmlFile, baseName .. "#foldMinLimit"), 0);
			entry.foldMaxLimit = Utils.getNoNil(getXMLFloat(xmlFile, baseName .. "#foldMaxLimit"), 1);

			table.insert(self.speedRotatingParts, entry);
		end;
		i = i+1;
	end;

end;

Windrower.load = Utils.appendedFunction(Windrower.load, Windrower.additionnalLoad1);






local oldWindrowerUpdateTick = Windrower.updateTick;
Windrower.updateTick = function(self, dt)

		if not self.isRealistic then
			return oldWindrowerUpdateTick(self, dt);
		end;

       self.wasToFast = false;
       if self:getIsActive() then
	   
		--****************************************  DURAL ********************************************
		--** reset totalRakedArea
			self.realLastRakedArea = 0;
	   
	   
           if self.isTurnedOn then
		   
				--****************************************  DURAL ********************************************
			   --** self.wasToFast = client side needing too !!!
			   --** variable speed limit
			   local toFast = self:doCheckSpeedLimit() and math.abs(self.lastSpeed)*3600 > self.realWorkingSpeedLimit;
			   self.wasToFast = toFast;
		   
               if self.isServer then
			   
                   if not toFast then
                       local x,y,z = getWorldTranslation(self.groundReferenceNode);
                       local terrainHeight = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x, 0, z);
                       if terrainHeight+self.groundReferenceThreshold >= y then
                           local numDropAreas = table.getn(self.windrowerDropAreas);
                           local numAreas = table.getn(self.cuttingAreas);
                           if numDropAreas > 0 and numAreas > 0 then
                               local cuttingAreasSend = {};
                               local dropAreasSend = {};
                               for i=1, numAreas do
                                   local cuttingArea = self.cuttingAreas[i];
                                   if self:getIsAreaActive(cuttingArea) then
                                       local x,_,z = getWorldTranslation(cuttingArea.start);
                                       local x1,_,z1 = getWorldTranslation(cuttingArea.width);
                                       local x2,_,z2 = getWorldTranslation(cuttingArea.height);
   
                                       table.insert(cuttingAreasSend, {x,z,x1,z1,x2,z2});
                                   end;
                               end;
                               for i=1, numDropAreas do
                                   local dropArea = self.windrowerDropAreas[i];
                                   local dx,dy,dz = getWorldTranslation(dropArea.start);
                                   local dx1,dy1,dz1 = getWorldTranslation(dropArea.width);
                                   local dx2,dy2,dz2 = getWorldTranslation(dropArea.height);
                                   table.insert(dropAreasSend, {dx, dz, dx1, dz1, dx2, dz2});
                               end;
                               if table.getn(cuttingAreasSend) > 0 then
							    --****************************************  DURAL ********************************************
								--** update totalRakedArea	
                                   local cuttingAreasSend, dropAreasSend, fruitType, bitType, rakedArea = WindrowAreaEvent.runLocallyEX1(cuttingAreasSend, dropAreasSend, self.accumulatedCuttingAreaValues, self.accumulatedFruitType);
								   self.realLastRakedArea = rakedArea;
                                   if table.getn(cuttingAreasSend) > 0 or table.getn(dropAreasSend) > 0 then
                                       self.accumulatedFruitType = fruitType
                                       g_server:broadcastEvent(WindrowAreaEvent:new(cuttingAreasSend, dropAreasSend, fruitType, bitType));
                                   end;
                               end;
                           end;
						   
                       end;
                   end; 
                   
               end;
   
               if self.isClient then
                   if not self.windrowerSoundEnabled and self:getIsActiveForSound() then
                       playSample(self.windrowerSound, 0, self.windrowerSoundVolume, 0);
                       setSamplePitch(self.windrowerSound, self.windrowerSoundPitchOffset);
                       self.windrowerSoundEnabled = true;
                   end;
               end;
           end;--end self.isturnedon
		   
		   if self.isClient then
				--*****************************************************  DURAL  **************************************************
				--** add speed rotating part...
				local foldAnimTime = self.foldAnimTime;
				for k,v in pairs(self.speedRotatingParts) do
					if foldAnimTime == nil or (foldAnimTime <= v.foldMaxLimit and foldAnimTime >= v.foldMinLimit) then
						rotate(v.node, v.rotationSpeedScale * 0.001 * self.realGroundSpeed * self.movingDirection * dt, 0, 0);
					end;
				end;
		   end;
		   		   
       end;-- end if self:getisactive
   end;
